/* eslint-disable camelcase */
const UserModel = require('../../../models/UserModel')
const jwt = require('jsonwebtoken')

const setCooperationType = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const { cooperation_type, cooperation_abroad } = req.body
    if (!cooperation_type || cooperation_abroad === undefined) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }
    if (!['all', 'verified'].includes(cooperation_type)) {
      return res.status(422).json({
        error: true,
        message: 'نوع همکاری نیست'
      })
    }

    // جستجوی کاربر با شماره موبایل ارسالی
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const user = await UserModel.findById(decodedToken.id)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }

    user.cooperation_type = cooperation_type
    user.cooperation_abroad = cooperation_abroad
    await user.save()

    return res.json({
      message: 'نوع همکاری با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}
const updateCooperationType = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')

    const { cooperation_type, cooperation_abroad } = req.body

    if (!cooperation_type || cooperation_abroad === undefined) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }

    if (!['all', 'verified'].includes(cooperation_type)) {
      return res.status(422).json({
        error: true,
        message: 'نوع همکاری نامعتبر است'
      })
    }

    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const userId = decodedToken.id

    // جستجوی کاربر با استفاده از شناسه کاربر
    const user = await UserModel.findById(userId)

    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شناسه یافت نشد'
      })
    }

    user.cooperation_type = cooperation_type
    user.cooperation_abroad = cooperation_abroad
    await user.save()

    return res.json({
      message: 'نوع همکاری با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}

module.exports = {
  setCooperationType,
  updateCooperationType
}
